# Algorithmes et structures de données

# Structure de pile

*****

## 1. Définition
Une pile est une structure de données dans laquelle la dernière information entrée, est la première à ressortir (en anglais : LIFO, Last In First Out)

On envisage deux types d'implémentation de piles:

1. l'une à capacité limitée (piles dénommées statiques);
2. l'autre à capacité « infinie » (piles dénommées dynamiques dont la capacité limite dépend en réalité de la mémoire disponible).

## 2. Spécification de la structure
Le  type des éléments qu'on empile, n'étant pas précisé, on parle de spécification générique.

Les opérations possibles sur une pile en définissent l'interface :

* Opérations de manipulation
    * Empiler un nouvel élément sur la pile
    * Dépiler l'élément au sommet de la pile (i.e. le dernier élément introduit)

* Fonctions de consultation
    * Lire l'élément au sommet de la pile
    * Tester si la pile est vide
    * Tester si la pile a atteint la capacité maximale, seulement dans le cas d'une pile statique
    * L'interface de la pile est l'ensemble des fonctionnalités offertes à l'utilisateur pour interagir avec une pile

## 3. Quelques applications des piles
* Gérer les mécanismes internes de mise en œuvre de la récursivité
* Traiter les structures imbriquées
* Implémenter les machines abstraites
* Passer les paramètres aux procédures
* Sauver l'état d'un processus